package cn.kdan.compdf.dto;

import com.fasterxml.jackson.annotation.JsonIgnore;
import lombok.Data;

import javax.validation.constraints.NotEmpty;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import java.util.List;

/**
 * @author Bob 2022-10-19
 */
@Data
public class EditWebhookDTO implements Serializable {

    /**
     * Webhook主键id
     */
    @NotNull(message = "id不能为空")
    private Long id;
    /**
     * 关联用户项目主键id
     */
    private Long projectId;
    /**
     * 接收服务端请求的回调地址
     */
    @NotEmpty(message = "Webhook URL cannot be blank")
    private String url;
    /**
     * Events主键id集合
     */
    @NotNull(message = "Please select at least one event")
    private List<Long> eventsId;

    /**
     * 关联用户主键id
     */
    @JsonIgnore
    private Long userId;
}
