package cn.kdan.compdf.service.impl;

import cn.kdan.compdf.entity.BackgroundTools;
import cn.kdan.compdf.mapper.BackgroundToolsMapper;
import cn.kdan.compdf.service.BackgroundToolsService;
import cn.kdan.compdf.vo.ToolQueryVO;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * @author ComPDF-Kit WPH 2022-10-09
 */
@Service
public class BackgroundToolsServiceImpl extends ServiceImpl<BackgroundToolsMapper, BackgroundTools> implements BackgroundToolsService {

    @Override
    public IPage<BackgroundTools> page(BackgroundTools query) {
        return this.page(new Page<>(query.getPage(), query.getSize()), Wrappers.query(query));
    }

    @Override
    public List<ToolQueryVO> getToolQueryS(){
        List<BackgroundTools> backgroundTools = this.baseMapper.selectList(new LambdaQueryWrapper<BackgroundTools>()
                .select(BackgroundTools::getId, BackgroundTools::getToolName));
        List<ToolQueryVO> toolQueryVOS = new ArrayList<>();
        backgroundTools.forEach(tool -> {
            toolQueryVOS.add(new ToolQueryVO(tool.getId(),tool.getToolName()));
        });
        return toolQueryVOS;
    }

}
