package cn.kdan.compdf.utils;

import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.LocalTime;
import java.time.temporal.ChronoUnit;

/**
 * @author ComPDFKit-WPH 2022/12/7
 *
 * localDate 工具类
 */
public class MyLocalDateUtil {

    private MyLocalDateUtil(){};

    /**
     * 时区转换 utc0到其他
     * @param localDateTime  时间
     * @param timeZone 时区
     * @return 新时间
     */
    public static LocalDateTime timeZoneConversion(LocalDateTime localDateTime,Integer timeZone){
        return localDateTime.plus(timeZone, ChronoUnit.HOURS);
    }

    /**
     * 时区转换 utc0到其他
     * @param localDateTime  时间
     * @param timeZone 时区
     * @return 新时间
     */
    public static LocalDateTime timeZoneConversion(LocalDate localDateTime, Integer timeZone){
        return localDateTime.atStartOfDay().plus(timeZone, ChronoUnit.HOURS);
    }


    /**
     * 获取整数小时时间
     */
    public static LocalDateTime getLocalDataTime() {
        LocalDateTime nowTime = LocalDateTime.now();
        LocalDate nowData = LocalDate.now();
        return LocalDateTime.of(nowData, LocalTime.of(nowTime.getHour(), 0));
    }

    public static boolean localDataCompareTo(LocalDateTime dateTime1, LocalDateTime dateTime2) {
        return dateTime1.compareTo(dateTime2) >= 0;
    }

    public static void main(String[] args) {


        System.out.println(LocalDateTime.now().toLocalDate());
        System.out.println(LocalDate.now());
        System.out.println(MyLocalDateUtil.timeZoneConversion(LocalDate.now(), Integer.valueOf("+08")));
    }



}
