package cn.kdan.compdf;

import cn.kdan.compdf.entity.dto.AnalysisDataDTO;
import cn.kdan.compdf.entity.dto.DashboardQueryDTO;
import cn.kdan.compdf.service.BackgroundConvertDataService;
import cn.kdan.compdf.service.BackgroundToolsService;
import cn.kdan.compdf.service.BackgroundUserProjectService;
import com.alibaba.excel.EasyExcel;
import com.alibaba.excel.ExcelWriter;
import com.alibaba.excel.annotation.ExcelIgnore;
import com.alibaba.excel.annotation.ExcelProperty;
import com.alibaba.excel.write.metadata.WriteSheet;
import lombok.*;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.time.chrono.ChronoLocalDateTime;
import java.time.temporal.ChronoUnit;
import java.time.temporal.TemporalUnit;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.concurrent.TimeUnit;

/**
 * @author ComPDFKit-WPH 2022/10/9
 */
@SpringBootTest
public class TestConvertDataService {
    @Autowired
    private BackgroundConvertDataService convertDataService;

    @Autowired
    private BackgroundToolsService toolsService;
    @Autowired
    private BackgroundUserProjectService projectService;
//    @Test
//    public void test01(){
//        DashboardQueryDTO dashboardQueryDTO = new DashboardQueryDTO();
////        dashboardQueryDTO.setDays(30);
//        dashboardQueryDTO.setEndDateTime(LocalDateTime.now());
//        dashboardQueryDTO.setStartDateTime(LocalDateTime.now().minus(20, ChronoUnit.DAYS));
//        dashboardQueryDTO.setQueryType(1);
//        dashboardQueryDTO.setProjectId(1L);
//        dashboardQueryDTO.setToolId(1L);
//        dashboardQueryDTO.setTenantId(1L);
//        AnalysisDataDTO analysisData = convertDataService.getAnalysisData(dashboardQueryDTO);
//        System.out.println(analysisData);
//    }
    @Test
    public void testGetToolQueryS(){
        System.out.println(toolsService.getToolQueryS());
    }
    @Test
    public void testGetProjectQuery(){
        System.out.println(projectService.getProjectQuery(1L));
    }


    public static void main(String[] args) {
        LocalDateTime now = LocalDateTime.now();
        LocalDate localDate = now.toLocalDate();
        LocalDateTime n1 = localDate.atStartOfDay();
        System.out.println(localDate);
        System.out.println(now.isBefore(n1));

    }


    @Getter
    @Setter
    @EqualsAndHashCode
    @AllArgsConstructor
    @NoArgsConstructor
    class DemoData {
        @ExcelProperty("字符串标题")
        private String string;
        @ExcelProperty("日期标题")
        private Date date;
        @ExcelProperty("数字标题")
        private Double doubleData;
        /**
         * 忽略这个字段
         */
        @ExcelIgnore
        private String ignore;
    }

    @Test
    public void simpleWrite() {

        String fileName = "C:\\Users\\00\\Desktop\\wangPH\\test\\" + "simpleWrite" + System.currentTimeMillis() + ".xlsx";
        // 这里 需要指定写用哪个class去写，然后写到第一个sheet，名字为模板 然后文件流会自动关闭
        // 如果这里想使用03 则 传入excelType参数即可
        ArrayList<DemoData> demoData = new ArrayList<>();
        demoData.add(new DemoData("1",new Date(),1.2,2+""));
        demoData.add(new DemoData("2",new Date(),1.3,3+""));

        EasyExcel.write(fileName, DemoData.class)
                .sheet("模板")
                .doWrite(() -> {
                    // 分页查询数据
                    return demoData;
                });
    }

}
